Index: /trunk/include/cf_base.h
===================================================================
--- /trunk/include/cf_base.h	(revision 115)
+++ /trunk/include/cf_base.h	(revision 116)
@@ -4,5 +4,5 @@
  * @version	0.1
  *
- * @remarks 기본 정의
+ * @brief 기본 정의
  *
  * @mainpage
Index: /trunk/include/cf_codec.h
===================================================================
--- /trunk/include/cf_codec.h	(revision 115)
+++ /trunk/include/cf_codec.h	(revision 116)
@@ -3,5 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark 데이터 변환
+ * @brief 데이터 변환
  *
  * @example codec.c
Index: /trunk/include/cf_debug.h
===================================================================
--- /trunk/include/cf_debug.h	(revision 115)
+++ /trunk/include/cf_debug.h	(revision 116)
@@ -3,5 +3,7 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark
+ * @brief 디버그 유틸
+ *
+ * @remarks
  * 디버그 함수를 직접 호출하지 않고 정의된 매크로를 사용하면,
  * Preprocessor에 _DEBUG가 정의되어 있는 경우에 만
Index: /trunk/include/cf_error.h
===================================================================
--- /trunk/include/cf_error.h	(revision 115)
+++ /trunk/include/cf_error.h	(revision 116)
@@ -3,5 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remarks 오류코드 모음
+ * @brief 오류코드 모음
  */
 #ifndef __CF_ERROR_H__
Index: /trunk/include/cf_file.h
===================================================================
--- /trunk/include/cf_file.h	(revision 115)
+++ /trunk/include/cf_file.h	(revision 116)
@@ -3,5 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remarks 파일 I/O
+ * @brief 파일 입출력
  *
  * @example file.c
Index: /trunk/include/cf_list.h
===================================================================
--- /trunk/include/cf_list.h	(revision 115)
+++ /trunk/include/cf_list.h	(revision 116)
@@ -2,4 +2,8 @@
  * @file	cf_list.h
  * @author	myusgun <myusgun@gmail.com>
+ *
+ * @brief 연결 리스트
+ *
+ * @example list.c
  */
 #ifndef __CF_LIST_H__
Index: /trunk/include/cf_log.h
===================================================================
--- /trunk/include/cf_log.h	(revision 115)
+++ /trunk/include/cf_log.h	(revision 116)
@@ -3,5 +3,7 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark
+ * @brief 로그
+ *
+ * @remarks
  * 매핑 ID 값을 이용하여 해당 로그에 기록 <br />
  * 로그 레벨을 적용할 때도 용이하며 define 이나 enumeration 등을 활용하면 좋음
Index: /trunk/include/cf_queue.h
===================================================================
--- /trunk/include/cf_queue.h	(revision 115)
+++ /trunk/include/cf_queue.h	(revision 116)
@@ -3,5 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark 큐
+ * @brief 큐
  *
  * @example queue.c
Index: /trunk/include/cf_socket.h
===================================================================
--- /trunk/include/cf_socket.h	(revision 115)
+++ /trunk/include/cf_socket.h	(revision 116)
@@ -3,5 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark TCP 소켓 지원
+ * @brief TCP 소켓 지원
  *
  * @example socket.c
Index: /trunk/include/cf_stack.h
===================================================================
--- /trunk/include/cf_stack.h	(revision 115)
+++ /trunk/include/cf_stack.h	(revision 116)
@@ -3,5 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark 스택
+ * @brief 스택
  *
  * @example stack.c
Index: /trunk/include/cf_thread.h
===================================================================
--- /trunk/include/cf_thread.h	(revision 115)
+++ /trunk/include/cf_thread.h	(revision 116)
@@ -3,5 +3,5 @@
  * @author	myusgun <myusgun@gmail.com>
  *
- * @remark 멀티스레드 및 뮤텍스 지원
+ * @brief 멀티스레드 및 뮤텍스 지원
  *
  * @example thread.c
Index: /trunk/src/cf_codec.c
===================================================================
--- /trunk/src/cf_codec.c	(revision 115)
+++ /trunk/src/cf_codec.c	(revision 116)
@@ -76,5 +76,5 @@
  * @param hex	16진수 문자열을 저장할 주소
  *
- * @remark
+ * @remarks
  * hex는 할당된 메모리이며, 크기는 '\0'를 제외하고 len * 2
  */
@@ -116,5 +116,5 @@
  * @param len	바이너리 데이터의 길이를 저장할 주소
  *
- * @remark
+ * @remarks
  * bin는 할당된 메모리이며, 크기는 strlen (hex) / 2
  */
@@ -182,5 +182,5 @@
  * @param base64	base64 문자열을 저장할 주소
  *
- * @remark
+ * @remarks
  * base64는 할당된 메모리이며, 크기는 '\0'를 제외하고 ((len + 2) / 3) * 4
  */
@@ -245,5 +245,5 @@
  * @param len		바이너리 데이터의 길이를 저장할 주소
  *
- * @remark
+ * @remarks
  * base64는 할당된 메모리이며, 크기는 (strlen (base64)) / 4 * 3
  */
Index: /trunk/src/cf_list.c
===================================================================
--- /trunk/src/cf_list.c	(revision 115)
+++ /trunk/src/cf_list.c	(revision 116)
@@ -135,5 +135,5 @@
  * @param element	삽입할 데이터 주소
  *
- * @remark
+ * @remarks
  * traverser가 NULL일 때,
  * direction이 CF_DIRECTION_BEFORE라면 Front 위치이고
Index: /trunk/src/cf_log.c
===================================================================
--- /trunk/src/cf_log.c	(revision 115)
+++ /trunk/src/cf_log.c	(revision 116)
@@ -448,5 +448,5 @@
  * @param ctx	로그 컨텍스트
  *
- * @remark 반드시 먼저 초기화 해야하며, 초기화 시에 주어진 번호보다 작은 아이디 넘버를 사용
+ * @remarks 반드시 먼저 초기화 해야하며, 초기화 시에 주어진 번호보다 작은 아이디 넘버를 사용
  *
  * @see CF_LOG_OPEN, CF_Log_CreateCtx
@@ -472,5 +472,5 @@
  * @param mapid 로그의 아이디 넘버
  *
- * @remark 아이디 넘버에 해당하는 컨텍스트가 해제되므로 주의
+ * @remarks 아이디 넘버에 해당하는 컨텍스트가 해제되므로 주의
  *
  * @see CF_LOG_CLOSE, CF_Log_DestroyCtx
Index: /trunk/src/cf_thread.c
===================================================================
--- /trunk/src/cf_thread.c	(revision 115)
+++ /trunk/src/cf_thread.c	(revision 116)
@@ -126,5 +126,5 @@
  * @param threadID 스레드 아이디 주소
  *
- * @remark 스레드 아이디를 해제하는 것이며 워커 스레드가 종료되지 않음
+ * @remarks 스레드 아이디를 해제하는 것이며 워커 스레드가 종료되지 않음
  */
 int