Index: trunk/docs/doxyfile
===================================================================
--- trunk/docs/doxyfile	(revision 35)
+++ trunk/docs/doxyfile	(revision 119)
@@ -213,5 +213,5 @@
 # itcl::class meaning.
 
-TCL_SUBST              = 
+#TCL_SUBST              = 
 
 # Set the OPTIMIZE_OUTPUT_FOR_C tag to YES if your project consists of C 
@@ -261,5 +261,5 @@
 # Disable only in case of backward compatibilities issues.
 
-MARKDOWN_SUPPORT       = YES
+#MARKDOWN_SUPPORT       = YES
 
 # When enabled doxygen tries to link words that correspond to documented classes, 
@@ -268,5 +268,5 @@
 # globally by setting AUTOLINK_SUPPORT to NO.
 
-AUTOLINK_SUPPORT       = YES
+#AUTOLINK_SUPPORT       = YES
 
 # If you use STL classes (i.e. std::string, std::vector, etc.) but do not want 
@@ -319,5 +319,5 @@
 # section (for LaTeX and RTF).
 
-INLINE_GROUPED_CLASSES = NO
+#INLINE_GROUPED_CLASSES = NO
 
 # When the INLINE_SIMPLE_STRUCTS tag is set to YES, structs, classes, and 
@@ -328,5 +328,5 @@
 # pages) or section (for LaTeX and RTF).
 
-INLINE_SIMPLE_STRUCTS  = NO
+#INLINE_SIMPLE_STRUCTS  = NO
 
 # When TYPEDEF_HIDES_STRUCT is enabled, a typedef of a struct, union, or enum 
@@ -365,5 +365,5 @@
 # corresponding to a cache size of 2^16 = 65536 symbols.
 
-LOOKUP_CACHE_SIZE      = 0
+#LOOKUP_CACHE_SIZE      = 0
 
 #---------------------------------------------------------------------------
@@ -386,5 +386,5 @@
 # scope will be included in the documentation.
 
-EXTRACT_PACKAGE        = NO
+#EXTRACT_PACKAGE        = NO
 
 # If the EXTRACT_STATIC tag is set to YES all static members of a file 
@@ -616,5 +616,5 @@
 # file names with spaces, bibtex cannot handle them.
 
-CITE_BIB_FILES         = 
+#CITE_BIB_FILES         = 
 
 #---------------------------------------------------------------------------
@@ -625,5 +625,5 @@
 # by doxygen. Possible values are YES and NO. If left blank NO is used.
 
-QUIET                  = NO
+QUIET                  = YES
 
 # The WARNINGS tag can be used to turn on/off the warning messages that are 
@@ -667,5 +667,5 @@
 # to stderr.
 
-WARN_LOGFILE           = 
+WARN_LOGFILE           = warning.log
 
 #---------------------------------------------------------------------------
@@ -800,5 +800,5 @@
 # the introduction page also for the doxygen output.
 
-USE_MDFILE_AS_MAINPAGE = 
+#USE_MDFILE_AS_MAINPAGE = 
 
 #---------------------------------------------------------------------------
@@ -937,5 +937,5 @@
 # the output directory.
 
-HTML_EXTRA_STYLESHEET  = 
+#HTML_EXTRA_STYLESHEET  = 
 
 # The HTML_EXTRA_FILES tag can be used to specify one or more extra images or 
@@ -946,5 +946,5 @@
 # the files will be copied as-is; there are no commands or markers available.
 
-HTML_EXTRA_FILES       = 
+#HTML_EXTRA_FILES       = 
 
 # The HTML_COLORSTYLE_HUE tag controls the color of the HTML output. 
@@ -994,5 +994,5 @@
 # and will result in a full expanded tree by default.
 
-HTML_INDEX_NUM_ENTRIES = 100
+#HTML_INDEX_NUM_ENTRIES = 100
 
 # If the GENERATE_DOCSET tag is set to YES, additional index files 
@@ -1215,5 +1215,5 @@
 # compatibility.
 
-MATHJAX_FORMAT         = HTML-CSS
+#MATHJAX_FORMAT         = HTML-CSS
 
 # When MathJax is enabled you need to specify the location relative to the 
@@ -1231,5 +1231,5 @@
 # names that should be enabled during MathJax rendering.
 
-MATHJAX_EXTENSIONS     = 
+#MATHJAX_EXTENSIONS     = 
 
 # When the SEARCHENGINE tag is enabled doxygen will generate a search box 
@@ -1261,5 +1261,5 @@
 # library Xapian. See the manual for configuration details.
 
-EXTERNAL_SEARCH        = NO
+#EXTERNAL_SEARCH        = NO
 
 # The SEARCHENGINE_URL should point to a search engine hosted by a web server 
@@ -1269,5 +1269,5 @@
 # details.
 
-SEARCHENGINE_URL       = 
+#SEARCHENGINE_URL       = 
 
 # When SERVER_BASED_SEARCH and EXTERNAL_SEARCH are both enabled the unindexed 
@@ -1275,5 +1275,5 @@
 # SEARCHDATA_FILE tag the name of this file can be specified.
 
-SEARCHDATA_FILE        = searchdata.xml
+#SEARCHDATA_FILE        = searchdata.xml
 
 # When SERVER_BASED_SEARCH AND EXTERNAL_SEARCH are both enabled the 
@@ -1282,5 +1282,5 @@
 # projects and redirect the results back to the right project.
 
-EXTERNAL_SEARCH_ID     = 
+#EXTERNAL_SEARCH_ID     = 
 
 # The EXTRA_SEARCH_MAPPINGS tag can be used to enable searching through doxygen 
@@ -1291,5 +1291,5 @@
 # The format is: EXTRA_SEARCH_MAPPINGS = id1=loc1 id2=loc2 ...
 
-EXTRA_SEARCH_MAPPINGS  = 
+#EXTRA_SEARCH_MAPPINGS  = 
 
 #---------------------------------------------------------------------------
@@ -1351,5 +1351,5 @@
 # standard footer. Notice: only use this tag if you know what you are doing!
 
-LATEX_FOOTER           = 
+#LATEX_FOOTER           = 
 
 # If the PDF_HYPERLINKS tag is set to YES, the LaTeX that is generated 
@@ -1390,5 +1390,5 @@
 # http://en.wikipedia.org/wiki/BibTeX for more info.
 
-LATEX_BIB_STYLE        = plain
+#LATEX_BIB_STYLE        = plain
 
 #---------------------------------------------------------------------------
@@ -1741,5 +1741,5 @@
 # exceeded by 50% before the limit is enforced.
 
-UML_LIMIT_NUM_FIELDS   = 10
+#UML_LIMIT_NUM_FIELDS   = 10
 
 # If set to YES, the inheritance and collaboration graphs will show the 
@@ -1805,5 +1805,5 @@
 # visible. Older versions of IE do not have SVG support.
 
-INTERACTIVE_SVG        = NO
+#INTERACTIVE_SVG        = NO
 
 # The tag DOT_PATH can be used to specify the path where the dot tool can be 