Index: trunk/src/cf_log.c
===================================================================
--- trunk/src/cf_log.c	(revision 125)
+++ trunk/src/cf_log.c	(revision 127)
@@ -4,5 +4,5 @@
  * \author	vfire
  *
- * \brief ·Î±× ±¸Çö
+ * \brief 로그 구현
  */
 #if defined(_WIN32) || defined(_WIN64)
@@ -56,5 +56,5 @@
 #define LOG_DATETIME_LENGTH				sizeof ("0000-00-00 00:00:00.000") - 1
 
-/** ·Î±× ÄÁÅØ½ºÆ® (Opaque) */
+/** 로그 컨텍스트 (Opaque) */
 typedef void *	CF_Log_Ctx;
 
@@ -72,5 +72,5 @@
 } CF_LOG_DATETIME;
 
-/** ·Î±× ÄÁÅØ½ºÆ® (CF_Log_CtxÀÇ ±¸Çö) */
+/** 로그 컨텍스트 (CF_Log_Ctx의 구현) */
 typedef struct __cf_log_ctx__
 {
@@ -173,5 +173,5 @@
 
 	snprintf (buffer, LOG_DATETIME_LENGTH,
-			  "%02d-%02d-%02d %02d:%02d:%02d.%03d",
+			  "%04d-%02d-%02d %02d:%02d:%02d.%03d",
 			  dt.year, dt.month, dt.day,
 			  dt.hour, dt.min, dt.sec, dt.usec);
@@ -192,11 +192,11 @@
 
 /**
- * ·Î±× µ¥ÀÌÅÍ Ã³¸®
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param ctx			·Î±× ÄÁÅØ½ºÆ®
- * \param buffer		·Î±× µ¥ÀÌÅÍ
- * \param demandSize	·Î±× µ¥ÀÌÅÍ ±æÀÌ
+ * 로그 데이터 처리
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx			로그 컨텍스트
+ * \param buffer		로그 데이터
+ * \param demandSize	로그 데이터 길이
  *
  * \author vfire
@@ -209,5 +209,5 @@
 	int result = CF_OK;
 
-	if (ctx->size > 0) /* ¹öÆÛ´ÜÀ§ ¹öÆÛ¸µ.... */
+	if (ctx->size > 0) /* 버퍼단위 버퍼링.... */
 	{
 		size_t writeSize;
@@ -228,5 +228,5 @@
 		}
 	}
-	else /* flushµÇ¾î¾ß ÇÔ. */
+	else /* flush되어야 함. */
 	{
 		ctx->buffer = (char *)buffer;
@@ -240,9 +240,9 @@
 
 /**
- * ·Î±× ÄÁÅØ½ºÆ®¿¡ ¸ÖÆ¼¾²·¹µå ¸ðµå ¼³Á¤
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå 
- *
- * \param ctx ·Î±× ÄÁÅØ½ºÆ®
+ * 로그 컨텍스트에 멀티쓰레드 모드 설정
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드 
+ *
+ * \param ctx 로그 컨텍스트
  *
  * \see CF_Log_UnsetMultiThread
@@ -262,9 +262,9 @@
 
 /**
- * ·Î±× ÄÁÅØ½ºÆ®¿¡ ¸ÖÆ¼¾²·¹µå ¸ðµå ¼³Á¤ ÇØÁ¦
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå 
- *
- * \param ctx ·Î±× ÄÁÅØ½ºÆ®
+ * 로그 컨텍스트에 멀티쓰레드 모드 설정 해제
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드 
+ *
+ * \param ctx 로그 컨텍스트
  *
  * \see CF_Log_SetMultiThread
@@ -286,12 +286,12 @@
 
 /**
- * ·Î±× ÄÁÅØ½ºÆ®¿¡ µû¶ó ·Î±× ¾²±â
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param ctx		·Î±× ÄÁÅØ½ºÆ®
- * \param prefix	·Î±×ÀÇ ÇÁ¸®ÇÈ½º ¹®ÀÚ¿­
- * \param fmt		Æ÷¸Ë ½ºÆ®¸µ
- * \param ...		°¡º¯ ÀÎÀÚ
+ * 로그 컨텍스트에 따라 로그 쓰기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx		로그 컨텍스트
+ * \param prefix	로그의 프리픽스 문자열
+ * \param fmt		포맷 스트링
+ * \param ...		가변 인자
  */
 static int
@@ -327,9 +327,9 @@
 
 /**
- * ·Î±× ¹öÆÛÀÇ µ¥ÀÌÅÍ¸¦ Áï½Ã ·Î±× ÆÄÀÏ¿¡ ¾²±â
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param ctx ·Î±× ÄÁÅØ½ºÆ®
+ * 로그 버퍼의 데이터를 즉시 로그 파일에 쓰기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx 로그 컨텍스트
  */
 static int
@@ -348,9 +348,9 @@
 
 /**
- * ·Î±× ÄÁÅØ½ºÆ® ÇØÁ¦
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå 
- *
- * \param ctx ·Î±× ÄÁÅØ½ºÆ®
+ * 로그 컨텍스트 해제
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드 
+ *
+ * \param ctx 로그 컨텍스트
  */
 static int
@@ -378,11 +378,11 @@
 
 /**
- * ·Î±× ÄÁÅØ½ºÆ® »ý¼º
- *
- * \return ¼º°ø ½Ã, ·Î±× ÄÁÅØ½ºÆ®; ½ÇÆÐ ½Ã, NULL
- *
- * \param ctx		·Î±× ÄÁÅØ½ºÆ® ÁÖ¼Ò
- * \param path		·Î±× ÆÄÀÏ °æ·Î
- * \param memsize	·Î±× ¹öÆÛ Å©±â
+ * 로그 컨텍스트 생성
+ *
+ * \return 성공 시, 로그 컨텍스트; 실패 시, NULL
+ *
+ * \param ctx		로그 컨텍스트 주소
+ * \param path		로그 파일 경로
+ * \param memsize	로그 버퍼 크기
  *
  * \see CF_LOG_DEFAULT_BUFFER, CF_LOG_NO_BUFFER
@@ -443,13 +443,13 @@
 
 /**
- * ·Î±× ÄÁÅØ½ºÆ®¿¡ ¾ÆÀÌµð ³Ñ¹ö ÇÒ´ç<br />
- * ·Î±× ±â·Ï ½Ã, ¾ÆÀÌµð ³Ñ¹ö¸¦ »ç¿ëÇÏ¸é ÇØ´ç ·Î±×·Î ±â·ÏÇÒ ¼ö ÀÖÀ½
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param mapid	ºÎ¿©ÇÒ ¾ÆÀÌµð ³Ñ¹ö
- * \param ctx	·Î±× ÄÁÅØ½ºÆ®
- *
- * \remarks ¹Ýµå½Ã ¸ÕÀú ÃÊ±âÈ­ ÇØ¾ßÇÏ¸ç, ÃÊ±âÈ­ ½Ã¿¡ ÁÖ¾îÁø ¹øÈ£º¸´Ù ÀÛÀº ¾ÆÀÌµð ³Ñ¹ö¸¦ »ç¿ë
+ * 로그 컨텍스트에 아이디 넘버 할당<br />
+ * 로그 기록 시, 아이디 넘버를 사용하면 해당 로그로 기록할 수 있음
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param mapid	부여할 아이디 넘버
+ * \param ctx	로그 컨텍스트
+ *
+ * \remarks 반드시 먼저 초기화 해야하며, 초기화 시에 주어진 번호보다 작은 아이디 넘버를 사용
  *
  * \see CF_LOG_OPEN, CF_Log_CreateCtx
@@ -469,11 +469,11 @@
 
 /**
- * ¾ÆÀÌµð ³Ñ¹ö¿¡ ÇØ´çÇÏ´Â ·Î±×¸¦ ´Ý°í ÇØ´çÇÏ´Â ÄÁÅØ½ºÆ®¸¦ ÇØÁ¦
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param mapid ·Î±×ÀÇ ¾ÆÀÌµð ³Ñ¹ö
- *
- * \remarks ¾ÆÀÌµð ³Ñ¹ö¿¡ ÇØ´çÇÏ´Â ÄÁÅØ½ºÆ®°¡ ÇØÁ¦µÇ¹Ç·Î ÁÖÀÇ
+ * 아이디 넘버에 해당하는 로그를 닫고 해당하는 컨텍스트를 해제
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param mapid 로그의 아이디 넘버
+ *
+ * \remarks 아이디 넘버에 해당하는 컨텍스트가 해제되므로 주의
  *
  * \see CF_LOG_CLOSE, CF_Log_DestroyCtx
@@ -495,10 +495,10 @@
 
 /**
- * ¾ÆÀÌµð ³Ñ¹ö¿¡ ÇØ´çÇÏ´Â ·Î±× ÄÁÅØ½ºÆ®¸¦ ¾ò±â
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param mapid	·Î±×ÀÇ ¾ÆÀÌµð ³Ñ¹ö
- * \param ctx	·Î±× ÄÁÅØ½ºÆ® ¹ÞÀ» ÁÖ¼Ò
+ * 아이디 넘버에 해당하는 로그 컨텍스트를 얻기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param mapid	로그의 아이디 넘버
+ * \param ctx	로그 컨텍스트 받을 주소
  */
 static int
@@ -516,9 +516,9 @@
 
 /**
- * ·Î±×¸¦ »ç¿ëÇÏ±â À§ÇØ ÃÊ±âÈ­
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param poolSize	·Î±× Ç® Å©±â·Î, ·Î±× ¾ÆÀÌµð ³Ñ¹öÀÇ ÃÖ´ë °ª
+ * 로그를 사용하기 위해 초기화
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param poolSize	로그 풀 크기로, 로그 아이디 넘버의 최대 값
  */
 int
@@ -540,7 +540,7 @@
 
 /**
- * ·Î±×°¡ ¸ðµÎ »ç¿ëµÈ ÈÄ ÀÚ¿ø ÇØÁ¦
- *
- * \return CF_OK ¹ÝÈ¯
+ * 로그가 모두 사용된 후 자원 해제
+ *
+ * \return CF_OK 반환
  */
 int
@@ -563,11 +563,11 @@
 
 /**
- * ·Î±× ¿­±â
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param mapid		·Î±×ÀÇ ¾ÆÀÌµð ³Ñ¹ö
- * \param path		·Î±× ÆÄÀÏ °æ·Î
- * \param memsize	·Î±× ¹öÆÛ Å©±â
+ * 로그 열기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param mapid		로그의 아이디 넘버
+ * \param path		로그 파일 경로
+ * \param memsize	로그 버퍼 크기
  *
  * \see CF_LOG_DEFAULT_BUFFER, CF_LOG_NO_BUFFER
@@ -593,9 +593,9 @@
 
 /**
- * ·Î±× ´Ý±â
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param mapid ·Î±×ÀÇ ¾ÆÀÌµð ³Ñ¹ö
+ * 로그 닫기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param mapid 로그의 아이디 넘버
  */
 int
@@ -606,9 +606,9 @@
 
 /**
- * ·Î±× ¹öÆÛÀÇ µ¥ÀÌÅÍ¸¦ Áï½Ã ·Î±× ÆÄÀÏ¿¡ ¾²±â
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param mapid ·Î±×ÀÇ ¾ÆÀÌµð ³Ñ¹ö
+ * 로그 버퍼의 데이터를 즉시 로그 파일에 쓰기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param mapid 로그의 아이디 넘버
  */
 int
@@ -628,10 +628,10 @@
 
 /**
- * ·Î±× ÄÁÅØ½ºÆ®¿¡ ¸ÖÆ¼¾²·¹µå ¸ðµå ¼³Á¤
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå 
- *
- * \param mapid	·Î±×ÀÇ ¾ÆÀÌµð ³Ñ¹ö
- * \param flag	¼³Á¤/ÇØÁ¦ bool ÇÃ·¡±×
+ * 로그 컨텍스트에 멀티쓰레드 모드 설정
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드 
+ *
+ * \param mapid	로그의 아이디 넘버
+ * \param flag	설정/해제 bool 플래그
  *
  * \see CF_BOOL
@@ -655,12 +655,12 @@
 
 /**
- * ·Î±× ¾²±â
- *
- * \return ¼º°ø ½Ã, CF_OK; ½ÇÆÐ ½Ã, ¿À·ù ÄÚµå
- *
- * \param mapid		·Î±×ÀÇ ¾ÆÀÌµð ³Ñ¹ö
- * \param prefix	·Î±×ÀÇ ÇÁ¸®ÇÈ½º ¹®ÀÚ¿­
- * \param fmt		Æ÷¸Ë ½ºÆ®¸µ
- * \param ...		°¡º¯ ÀÎÀÚ
+ * 로그 쓰기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param mapid		로그의 아이디 넘버
+ * \param prefix	로그의 프리픽스 문자열
+ * \param fmt		포맷 스트링
+ * \param ...		가변 인자
  */
 int